"""
This file is generated by the openapi-python-client tool via the generate_api_client.py script

It is a customized template from the openapi-python-client tool's default template:
https://github.com/openapi-generators/openapi-python-client/blob/861ef5622f10fc96d240dc9becb0edf94e61446c/openapi_python_client/templates/endpoint_module.py.jinja

The main changes are:
- Update the API call responses to either return the successful response type or raise an error by:
    - Updating the _parse_response function to raise an error if the response status code is not in the 2xx range
- Inject a client into every method via a context manager
"""

from http import HTTPStatus
from typing import Any, Union

import httpx

from ...client import _client_context
from ...errors import get_error_for_response
from ...models.labeled_memory import LabeledMemory
from ...models.scored_memory import ScoredMemory
from ...types import Response


def _get_kwargs(
    name_or_id: str,
    memory_id: str,
) -> dict[str, Any]:
    _kwargs: dict[str, Any] = {
        "method": "get",
        "url": f"/memoryset/{name_or_id}/memory/{memory_id}",
    }

    return _kwargs


def _parse_response(*, response: httpx.Response) -> Union["LabeledMemory", "ScoredMemory"]:
    if response.status_code == 200:

        def _parse_response_200(data: object) -> Union["LabeledMemory", "ScoredMemory"]:
            try:
                if not isinstance(data, dict):
                    raise TypeError()
                response_200_type_0 = LabeledMemory.from_dict(data)

                return response_200_type_0
            except:  # noqa: E722
                pass
            if not isinstance(data, dict):
                raise TypeError()
            response_200_type_1 = ScoredMemory.from_dict(data)

            return response_200_type_1

        response_200 = _parse_response_200(response.json())

        return response_200
    if response.status_code == 401:
        raise get_error_for_response(response)
    if response.status_code == 500:
        raise get_error_for_response(response)
    if response.status_code == 503:
        raise get_error_for_response(response)
    if response.status_code == 404:
        raise get_error_for_response(response)
    else:
        raise get_error_for_response(response)


def _build_response(*, response: httpx.Response) -> Response[Union["LabeledMemory", "ScoredMemory"]]:
    return Response(
        status_code=HTTPStatus(response.status_code),
        content=response.content,
        headers=response.headers,
        parsed=_parse_response(response=response),
    )


def sync_detailed(
    name_or_id: str,
    memory_id: str,
) -> Response[Union["LabeledMemory", "ScoredMemory"]]:
    """Get Memory

    Args:
        name_or_id (str):
        memory_id (str): ID of the memory

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[Union['LabeledMemory', 'ScoredMemory']]
    """

    kwargs = _get_kwargs(
        name_or_id=name_or_id,
        memory_id=memory_id,
    )

    with _client_context() as client:
        response = client.get_httpx_client().request(
            **kwargs,
        )

        return _build_response(response=response)


def sync(
    name_or_id: str,
    memory_id: str,
) -> Union["LabeledMemory", "ScoredMemory"]:
    """Get Memory

    Args:
        name_or_id (str):
        memory_id (str): ID of the memory

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Union['LabeledMemory', 'ScoredMemory']
    """

    return sync_detailed(
        name_or_id=name_or_id,
        memory_id=memory_id,
    ).parsed


async def asyncio_detailed(
    name_or_id: str,
    memory_id: str,
) -> Response[Union["LabeledMemory", "ScoredMemory"]]:
    """Get Memory

    Args:
        name_or_id (str):
        memory_id (str): ID of the memory

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[Union['LabeledMemory', 'ScoredMemory']]
    """

    kwargs = _get_kwargs(
        name_or_id=name_or_id,
        memory_id=memory_id,
    )

    with _client_context() as client:
        response = await client.get_async_httpx_client().request(**kwargs)

    return _build_response(response=response)


async def asyncio(
    name_or_id: str,
    memory_id: str,
) -> Union["LabeledMemory", "ScoredMemory"]:
    """Get Memory

    Args:
        name_or_id (str):
        memory_id (str): ID of the memory

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Union['LabeledMemory', 'ScoredMemory']
    """

    return (
        await asyncio_detailed(
            name_or_id=name_or_id,
            memory_id=memory_id,
        )
    ).parsed
