"""
This file is generated by the openapi-python-client tool via the generate_api_client.py script

It is a customized template from the openapi-python-client tool's default template:
https://github.com/openapi-generators/openapi-python-client/blob/861ef5622f10fc96d240dc9becb0edf94e61446c/openapi_python_client/templates/endpoint_module.py.jinja

The main changes are:
- Update the API call responses to either return the successful response type or raise an error by:
    - Updating the _parse_response function to raise an error if the response status code is not in the 2xx range
- Inject a client into every method via a context manager
"""

from enum import Enum
from http import HTTPStatus
from typing import Any, Dict, List, Union

import httpx

from ...client import _client_context
from ...errors import get_error_for_response
from ...models.memory_type import MemoryType
from ...models.memoryset_metadata import MemorysetMetadata
from ...types import UNSET, Response, Unset


def _get_kwargs(
    *,
    type: Union[MemoryType, None, Unset] = UNSET,
) -> dict[str, Any]:
    params: Dict[str, Any] = {}

    json_type: Union[None, Unset, str]
    if isinstance(type, Unset):
        json_type = UNSET
    elif isinstance(type, MemoryType):
        json_type = type.value if isinstance(type, Enum) else type
    else:
        json_type = type
    params["type"] = json_type

    params = {k: v for k, v in params.items() if v is not UNSET and v is not None}

    _kwargs: dict[str, Any] = {
        "method": "get",
        "url": "/memoryset/",
        "params": params,
    }

    return _kwargs


def _parse_response(*, response: httpx.Response) -> List["MemorysetMetadata"]:
    if response.status_code == 200:
        response_200 = []
        _response_200 = response.json()
        for response_200_item_data in _response_200:
            response_200_item = MemorysetMetadata.from_dict(response_200_item_data)

            response_200.append(response_200_item)

        return response_200
    if response.status_code == 401:
        raise get_error_for_response(response)
    if response.status_code == 500:
        raise get_error_for_response(response)
    if response.status_code == 503:
        raise get_error_for_response(response)
    else:
        raise get_error_for_response(response)


def _build_response(*, response: httpx.Response) -> Response[List["MemorysetMetadata"]]:
    return Response(
        status_code=HTTPStatus(response.status_code),
        content=response.content,
        headers=response.headers,
        parsed=_parse_response(response=response),
    )


def sync_detailed(
    *,
    type: Union[MemoryType, None, Unset] = UNSET,
) -> Response[List["MemorysetMetadata"]]:
    """List Memorysets

    Args:
        type (Union[MemoryType, None, Unset]):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[List['MemorysetMetadata']]
    """

    kwargs = _get_kwargs(
        type=type,
    )

    with _client_context() as client:
        response = client.get_httpx_client().request(
            **kwargs,
        )

        return _build_response(response=response)


def sync(
    *,
    type: Union[MemoryType, None, Unset] = UNSET,
) -> List["MemorysetMetadata"]:
    """List Memorysets

    Args:
        type (Union[MemoryType, None, Unset]):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        List['MemorysetMetadata']
    """

    return sync_detailed(
        type=type,
    ).parsed


async def asyncio_detailed(
    *,
    type: Union[MemoryType, None, Unset] = UNSET,
) -> Response[List["MemorysetMetadata"]]:
    """List Memorysets

    Args:
        type (Union[MemoryType, None, Unset]):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[List['MemorysetMetadata']]
    """

    kwargs = _get_kwargs(
        type=type,
    )

    with _client_context() as client:
        response = await client.get_async_httpx_client().request(**kwargs)

    return _build_response(response=response)


async def asyncio(
    *,
    type: Union[MemoryType, None, Unset] = UNSET,
) -> List["MemorysetMetadata"]:
    """List Memorysets

    Args:
        type (Union[MemoryType, None, Unset]):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        List['MemorysetMetadata']
    """

    return (
        await asyncio_detailed(
            type=type,
        )
    ).parsed
