"""
This file is generated by the openapi-python-client tool via the generate_api_client.py script

It is a customized template from the openapi-python-client tool's default template:
https://github.com/openapi-generators/openapi-python-client/blob/861ef5622f10fc96d240dc9becb0edf94e61446c/openapi_python_client/templates/model.py.jinja

The main change is:
- Fix typing issues
"""

# flake8: noqa: C901

from typing import TYPE_CHECKING, Any, Type, TypeVar

from attrs import define as _attrs_define
from attrs import field as _attrs_field

if TYPE_CHECKING:
    from ..models.labeled_memory_lookup import LabeledMemoryLookup


T = TypeVar("T", bound="CascadingEditSuggestion")


@_attrs_define
class CascadingEditSuggestion:
    """
    Attributes:
        neighbor (LabeledMemoryLookup): Single labeled memory lookup result.
        suggested_label (int):
        lookup_score (float):
    """

    neighbor: "LabeledMemoryLookup"
    suggested_label: int
    lookup_score: float
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        neighbor = self.neighbor.to_dict()

        suggested_label = self.suggested_label

        lookup_score = self.lookup_score

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update(
            {
                "neighbor": neighbor,
                "suggested_label": suggested_label,
                "lookup_score": lookup_score,
            }
        )

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: dict[str, Any]) -> T:
        from ..models.labeled_memory_lookup import LabeledMemoryLookup

        d = src_dict.copy()
        neighbor = LabeledMemoryLookup.from_dict(d.pop("neighbor"))

        suggested_label = d.pop("suggested_label")

        lookup_score = d.pop("lookup_score")

        cascading_edit_suggestion = cls(
            neighbor=neighbor,
            suggested_label=suggested_label,
            lookup_score=lookup_score,
        )

        cascading_edit_suggestion.additional_properties = d
        return cascading_edit_suggestion

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
