"""
This file is generated by the openapi-python-client tool via the generate_api_client.py script

It is a customized template from the openapi-python-client tool's default template:
https://github.com/openapi-generators/openapi-python-client/blob/861ef5622f10fc96d240dc9becb0edf94e61446c/openapi_python_client/templates/model.py.jinja

The main change is:
- Fix typing issues
"""

# flake8: noqa: C901

from typing import TYPE_CHECKING, Any, Dict, Type, TypeVar, Union, cast

from attrs import define as _attrs_define

from ..types import UNSET, Unset

if TYPE_CHECKING:
    from ..models.scored_memory_insert_metadata import ScoredMemoryInsertMetadata


T = TypeVar("T", bound="ScoredMemoryInsert")


@_attrs_define
class ScoredMemoryInsert:
    """Model of fields required for inserting a scored memory.

    Attributes:
        value (str):
        score (float):
        memory_id (Union[None, Unset, str]):
        metadata (Union[Unset, ScoredMemoryInsertMetadata]):
        source_id (Union[None, Unset, str]):
    """

    value: str
    score: float
    memory_id: Union[None, Unset, str] = UNSET
    metadata: Union[Unset, "ScoredMemoryInsertMetadata"] = UNSET
    source_id: Union[None, Unset, str] = UNSET

    def to_dict(self) -> dict[str, Any]:
        value: str
        value = self.value

        score = self.score

        memory_id: Union[None, Unset, str]
        if isinstance(self.memory_id, Unset):
            memory_id = UNSET
        else:
            memory_id = self.memory_id

        metadata: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.metadata, Unset):
            metadata = self.metadata.to_dict()

        source_id: Union[None, Unset, str]
        if isinstance(self.source_id, Unset):
            source_id = UNSET
        else:
            source_id = self.source_id

        field_dict: dict[str, Any] = {}
        field_dict.update(
            {
                "value": value,
                "score": score,
            }
        )
        if memory_id is not UNSET:
            field_dict["memory_id"] = memory_id
        if metadata is not UNSET:
            field_dict["metadata"] = metadata
        if source_id is not UNSET:
            field_dict["source_id"] = source_id

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: dict[str, Any]) -> T:
        from ..models.scored_memory_insert_metadata import ScoredMemoryInsertMetadata

        d = src_dict.copy()

        def _parse_value(data: object) -> str:
            return cast(str, data)

        value = _parse_value(d.pop("value"))

        score = d.pop("score")

        def _parse_memory_id(data: object) -> Union[None, Unset, str]:
            if data is None:
                return data
            if isinstance(data, Unset):
                return data
            return cast(Union[None, Unset, str], data)

        memory_id = _parse_memory_id(d.pop("memory_id", UNSET))

        _metadata = d.pop("metadata", UNSET)
        metadata: Union[Unset, ScoredMemoryInsertMetadata]
        if isinstance(_metadata, Unset):
            metadata = UNSET
        else:
            metadata = ScoredMemoryInsertMetadata.from_dict(_metadata)

        def _parse_source_id(data: object) -> Union[None, Unset, str]:
            if data is None:
                return data
            if isinstance(data, Unset):
                return data
            return cast(Union[None, Unset, str], data)

        source_id = _parse_source_id(d.pop("source_id", UNSET))

        scored_memory_insert = cls(
            value=value,
            score=score,
            memory_id=memory_id,
            metadata=metadata,
            source_id=source_id,
        )

        return scored_memory_insert
